﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace _135646
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {


            DataSet ds = new DataSet();
            DataTable parent = ds.Tables.Add("parent");
            parent.Columns.Add("id", typeof(int)).AutoIncrement = true;
            parent.Columns.Add("Column 1", typeof(string)).DefaultValue = "Column 1";
            parent.Columns.Add("Column 2", typeof(string)).DefaultValue = "Column 2";

            DataTable level1 = ds.Tables.Add("Table1");
            level1.Columns.Add("id", typeof(int));
            level1.Columns.Add("Summary Value", typeof(string));

            ds.Relations.Add("MiddleTable1", parent.Columns["id"], level1.Columns["id"]);

            geneareTable("License", ds.Tables["Table1"], "id");
            geneareTable("Summary", ds.Tables["Table1"], "id");
            geneareTable("Version", ds.Tables["Table1"], "id");
            geneareTable("Episode", ds.Tables["Table1"], "id");

            Random rnd = new Random();

            for (int i = 0; i < 10; i++)
            {
                DataRow parentRow = parent.Rows.Add();
                DataRow row = level1.Rows.Add(parentRow[0]);
                foreach (DataRelation midRel in level1.ChildRelations)
                {
                    Thread.Sleep(2);
                    DataTable midDt = midRel.ChildTable;
                    row = midDt.Rows.Add(row["id"]);
                    foreach (DataRelation rel in midDt.ChildRelations)
                    {
                        DataTable dt = rel.ChildTable;
                        int childRows = rnd.Next(1, 100);
                        for (int j = 0; j < childRows; j++)
                        {
                            dt.Rows.Add(row["id"]);
                        }
                    }
                }
            }


            ultraGrid1.DataSource = ds;

       
        }

        private DataTable geneareTable(string tabelName, DataTable parentTable, string parentColumnId)
        {
            DataTable dt = parentTable.DataSet.Tables.Add(tabelName);
            dt.Columns.Add("pid", typeof(int));
            dt.Columns.Add("id", typeof(int)).AutoIncrement = true;
            dt.Columns.Add("Row Type", typeof(string)).Expression = string.Format("'{0}'",tabelName);
            dt.Columns.Add("Some Text" , typeof(string)).DefaultValue = string.Format("Some test string for {0}", tabelName);

            DataTable middleDT = parentTable.DataSet.Tables.Add(string.Format("Middle{0}", tabelName));
            middleDT.Columns.Add(parentColumnId, typeof(int));
            middleDT.Columns.Add("Summary Value", typeof(string));

            parentTable.DataSet.Relations.Add(string.Format("MiddleRelation{0}", middleDT.TableName), parentTable.Columns[parentColumnId], middleDT.Columns[parentColumnId]);

            parentTable.DataSet.Relations.Add(string.Format("TableRelation{0}", tabelName), middleDT.Columns[parentColumnId], dt.Columns["pid"]);

            return dt;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {

            e.Layout.Override.AllowColSizing = AllowColSizing.Free;
            
            foreach (UltraGridBand band in e.Layout.Bands)
            {
                if (band.Key.StartsWith("Middle"))
                    AdjustMiddleBand(band);
            }
        }

        private void AdjustMiddleBand(UltraGridBand band)
        {
            band.ColHeadersVisible = false;
            band.Columns[0].Hidden = true;
            band.Columns[1].Width = 500;
            band.Columns[1].CellActivation = Activation.ActivateOnly;
            band.Override.RowSelectors = Infragistics.Win.DefaultableBoolean.False;
            band.Override.BorderStyleCell = Infragistics.Win.UIElementBorderStyle.None;
            band.Override.BorderStyleRow = Infragistics.Win.UIElementBorderStyle.None;
        }

        private void ultraGrid1_InitializeRow(object sender, InitializeRowEventArgs e)
        {
            if(e.Row.Band.Key.StartsWith("Middle"))
            {
                StringBuilder label = new StringBuilder();
                label.Append("Row Type:");
                DataRow row = ((DataRowView)e.Row.ListObject).Row;
                 foreach (DataRelation rel in row.Table.ChildRelations)
                 {
                    int childRowsCount =  -1;
                    string childTableName = "None";
                    GetchildRowTable(ref childRowsCount, ref childTableName, row, rel);
                    label.AppendFormat("{0} ({1} items), ", childTableName, childRowsCount);
                }

                 e.Row.Cells[1].Value = label.ToString();
            }
        }

        private void GetchildRowTable(ref int childRowsCount, ref string childTableName, DataRow row, DataRelation rel)
        {
            if (rel.RelationName.StartsWith("Middle"))
            {
                DataRow middRow = row.GetChildRows(rel).FirstOrDefault();
                if (middRow != null)
                {
                    GetchildRowTable(ref childRowsCount, ref childTableName, middRow, middRow.Table.ChildRelations[0]);
                }
            }
            else
            {
                childRowsCount = row.GetChildRows(rel).Count();
                 childTableName = rel.ChildTable.TableName;
            }

        }
        
    }
}
